/* this file implements the class Heap */

#include "heap.h"
#include "../func/gendef.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

//------------------------------------------
HeapEntry::HeapEntry()
{
}
//------------------------------------------
HeapEntry::~HeapEntry()
{
	delete []bitchars;
}
//------------------------------------------
void HeapEntry::init_HeapEntry(int _bitcharlen)
{
	bitcharlen=_bitcharlen;
	key=0; 
	bitchars=new unsigned char[_bitcharlen];
}
//------------------------------------------
void HeapEntry::copy(HeapEntry *_he)
{
	key = _he -> key;
	level = _he -> level;
	son = _he -> son;
	ed = _he->ed;
	memcpy(bitchars, _he->bitchars, bitcharlen);
}
//------------------------------------------
Heap::Heap()
{
	cont = NULL;
}
//------------------------------------------
Heap::~Heap()
{
	delete [] cont;
	cont = NULL;
}
//------------------------------------------
void Heap::init(int _hsize, int _bitcharlen)
{
	hsize=_hsize; used=0; bitcharlen=_bitcharlen;
	if (cont)
		delete []cont;
	cont=new HeapEntry[_hsize];
	for (int i=0; i<_hsize; i++)
		cont[i].init_HeapEntry(_bitcharlen);
	printf("heap size=%d\n", hsize);
}
//------------------------------------------
void Heap::insert(HeapEntry *_he)
{  
	if (used == hsize)  
	{
		printf("used=%d, hsize=%d", used, hsize);
		error("heap exceeded...\n", true);
	}
	
	enter(_he, used);  //used is incremented in this function
	// now perform swapping
	int parent = used;
	while (parent != 1)
	{
		int child = parent;
		parent /= 2;
		if (cont[parent - 1].key > cont[child - 1].key)
		{
			HeapEntry *the = new HeapEntry();
			the -> init_HeapEntry(cont[parent - 1].bitcharlen);
			the -> copy(&(cont[parent - 1]));
			cont[parent - 1].copy(&(cont[child - 1]));
			cont[child - 1].copy(the);
			delete the;
		}
		else 
			parent = 1;
	}
}
//------------------------------------------
bool Heap::remove(HeapEntry *_he)
//this function deheaps an entry. the return value indicates whether successful: false
//means heap is already empty
{
	if (used == 0)
	{
		return false;
	}
	
	_he -> copy(&(cont[0]));
	used--;
	cont[0].copy(&(cont[used]));

	int parent = 1;
	while (2 * parent <= used)
	{
		int child = 2 * parent;
		if (2 * parent + 1 > used)
			child = 2 * parent;
		else
			if (cont[2 * parent - 1].key < cont[2 * parent].key)
				child = 2 * parent;
			else 
				child = 2 * parent + 1;

		if (cont[parent - 1].key > cont[child - 1].key)
		{
			HeapEntry *the = new HeapEntry();
			the -> init_HeapEntry(cont[parent - 1].bitcharlen);
			the -> copy(&(cont[parent - 1]));
			cont[parent - 1].copy(&(cont[child - 1]));
			cont[child - 1].copy(the);
			delete the;
			parent = child; 
		}
		else
			parent = used;
	}
	
	return true;
};
//------------------------------------------
void Heap::enter(HeapEntry *_he, int _pos)
//this function enters a new entry into the heap at position _pos
{

	for (int i = used - 1; i >= _pos; i --)
	{
		cont[i + 1].copy(&(cont[i]));
	}
	cont[_pos].copy(_he);
	used ++;
}
