// Random.cpp: implementation of the Random class.
//
//////////////////////////////////////////////////////////////////////

#include "Random.h"
#include <time.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Random::Random()
{
	_int64 tmp = (_int64)1L;
	multiplier = (_int64)0x5DEECE66DL;
    addend = (_int64)0xBL;
    mask = (tmp << 48) - 1;
	haveNextNextGaussian = false;
	BITS_PER_BYTE = 8;
	BYTES_PER_INT = 8;
	Random((_int64)time( 0 ));
}

Random::~Random()
{

}

Random::Random(_int64 seed)
{
	_int64 tmp = (_int64)1L;
	multiplier =(_int64) 0x5DEECE66DL;
    addend = (_int64)0xBL;
    mask = (tmp << 48) - 1;
	haveNextNextGaussian = false;
	BITS_PER_BYTE = 8;
	BYTES_PER_INT = 8;
	this->setSeed(seed);
}	

void Random::setSeed(_int64 seed)
{
	  this->seed = (seed ^ this->multiplier) & this->mask;
      this->haveNextNextGaussian = false;
}

int Random::next(int bits) {
        _int64 nextseed = (seed * multiplier + addend) & mask;
        seed = nextseed;
        _int64 tmpSeed =  nextseed >> (48 - bits) ;
		return (int)(tmpSeed & 0x7FFFFFFF);
		//return tmpSeed;
    }

int Random::nextInt() {  return next(32); }

double Random::nextDouble() {
        _int64 l = ((_int64)(next(26)) << 27) + next(27);
        return (double)(l / (double)(1L << 53));
    }

bool Random::nextBoolean() {return next(1) != 0;}

float Random::nextFloat() {
        int i = next(24);
        return i / ((float)(1 << 24));
    }

int Random::nextInt(int n) {
        
        if ((n & -n) == n)  // i.e., n is a power of 2
            return (int)((n * (_int64)(next(31))) >> 31);

        int bits, val;
        do {
            bits = next(31);
            val = bits % n;
        } while(bits - val + (n-1) < 0);
        return val;
    }